% % LLS (2017) % %
% function gramschmidt.m
% Gram-Schmidt orthonormalization (note that result a: a'a = rows(a)*I)
function b = gramschmidt(a)
tt = size(a,1); 
m = size(a,2);
b = a;
for j = 2:m
    bhatj = (b(:,1:(j-1))'*b(:,1:(j-1)))\(b(:,1:(j-1))'*b(:,j));
    b(:,j) = b(:,j)-b(:,1:(j-1))*bhatj;
end;
b = b./( ones(tt,1)*sqrt(mean(b.*b)) );
b'*b/tt;
