% % LLS (2017) % %
% Exact implied time domain kernel of orthogonal basis function

function [ktime,kfreq] = impliedkernel(pbasis)
% pbasis: basis functions
tt = size(pbasis,1); 
ndf = size(pbasis,2);
k = zeros(tt,1);
for j = 1:tt;
    for m = 1:ndf;
        k(j) = k(j) + pbasis(1:(tt-j+1),m)'*pbasis(j:tt,m);
    end;
end;
ktime = k/(ndf*pbasis(:,1)'*pbasis(:,1));
ktime = ktime./(1-(0:(tt-1)/tt));
kfreq = zeros(tt,1);
om1 = 2*pi*(1:(tt-1))'/tt;
for j = 1:tt;
    kfreq(j) = ktime(1) + 2*cos(om1*(j-1))'*ktime(2:end);
end;
kfreq = kfreq/(tt/ndf);
